<!DOCTYPE html>
<html lang="en">

<head>

    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Load all orders - Danh sách đơn hàng</title>
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
</head>

<body onload="onPageLoading()">
    <div class="container-fluid pt-4">
        <h2 class="text-center pb-3">Danh sách đơn hàng</h2>
        <table class="table text-center table-striped" id="table-order">
            <thead>
                <tr>
                    <th scope="col">Order Code</th>
                    <th scope="col">Kích cỡ combo</th>
                    <th scope="col">Loại pizza</th>
                    <th scope="col">Nước uống</th>
                    <th scope="col">Thành tiền</th>
                    <th scope="col">Họ và tên</th>
                    <th scope="col">Số điện thoại</th>
                    <th scope="col">Trạng thái</th>
                    <th scope="col">Chi tiết</th>
                </tr>
            </thead>
            <tbody>

            </tbody>
        </table>
    </div>

    <script>
        "use strict";
        /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
        const gREQUEST_STATUS_OK = 200;
        const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
        const gLAST_ROW_COL = -1;

        /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */


        /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
        // Hàm thực hiện khi load trang
        function onPageLoading() {
            getAllOrders();
        }

        // Hàm xử lý sự kiện click button chi tiết
        function onBtnOrderDetailClick(paramButtonDetail) {
            //var vId = paramButtonDetail.dataset.id;
            var vId = paramButtonDetail.getAttribute("data-id");
            //var vOrderCode = paramButtonDetail.dataset.ordercode;
            var vOrderCode = paramButtonDetail.getAttribute("ordercode");

            console.log("id: " + vId);
            console.log("Order Code: " + vOrderCode);
        }
        /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
        // Hàm thực hiện việc load all orders từ server và load vào table
        function getAllOrders() {
            /**
           * Chia để trị - 04 bước cố gắng thành 04 functions riêng biệt
           */
            // B1: Thu thập dữ liệu (trong bài này bước này ko cần)
            // B2: Validate dữ liệu (trong bài này bước này ko cần)
            // B3: Thực hiện việc gọi API từ server Server
            var vXmlHttpGetAllOrders = new XMLHttpRequest();
            callApiToGetAllOrders(vXmlHttpGetAllOrders);

            // B4: Xử lý trên front-end khi request xử lý xong và trả về response thành công
            vXmlHttpGetAllOrders.onreadystatechange = function () {
                if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
                    loadOrderToTable(vXmlHttpGetAllOrders);
                }
            }
        }

        // hàm gọi api để lấy all orders
        function callApiToGetAllOrders(paramXMLHttpGetAllOrders) {
            const vBaseUrl = "http://203.171.20.210:8080/devcamp-pizza365/orders";
            paramXMLHttpGetAllOrders.open("GET", vBaseUrl, true);
            paramXMLHttpGetAllOrders.send();
        }

        // input: xml http request đã đươc trả lời
        // ouptut/end: dữ liệu hiên thi trên bảng
        function loadOrderToTable(paramXMLHttpAllOrder) {
            //CODE Ở ĐÂY ĐỂ LOAD DATA VÀO TABLE
            console.log(paramXMLHttpAllOrder.responseText);
            //chuyển kết quả api thành mảng order
            var listOrderObjects = JSON.parse(paramXMLHttpAllOrder.responseText);

            //fill dữ liệu vào table
            var vTableBodyOrder = document.getElementsByTagName("tbody")[0];

            for (var bI = 0; bI < listOrderObjects.length; bI++ ) {
                //thêm row
                var bOrderRow = vTableBodyOrder.insertRow(gLAST_ROW_COL);
                //thêm các cột
                var bOrderCodeCol = bOrderRow.insertCell(gLAST_ROW_COL);
                var bOrderSizeCol = bOrderRow.insertCell(gLAST_ROW_COL);
                var bOrderPizzaTypeCol = bOrderRow.insertCell(gLAST_ROW_COL);
                var bOrderDrinkCol = bOrderRow.insertCell(gLAST_ROW_COL);
                var bOrderTotalCol = bOrderRow.insertCell(gLAST_ROW_COL);
                var bOrderFullNameCol = bOrderRow.insertCell(gLAST_ROW_COL);
                var bOrderPhoneCol = bOrderRow.insertCell(gLAST_ROW_COL);
                var bOrderStatusCol = bOrderRow.insertCell(gLAST_ROW_COL);
                var bOrderDetailCol = bOrderRow.insertCell(gLAST_ROW_COL);

                //gán dữ liệu cho các cột
                bOrderCodeCol.innerHTML = listOrderObjects[bI].orderCode;
                bOrderSizeCol.innerHTML = listOrderObjects[bI].kichCo;
                bOrderPizzaTypeCol.innerHTML = listOrderObjects[bI].loaiPizza;
                bOrderDrinkCol.innerHTML = listOrderObjects[bI].idLoaiNuocUong;
                bOrderTotalCol.innerHTML = listOrderObjects[bI].thanhTien;
                bOrderFullNameCol.innerHTML = listOrderObjects[bI].hoTen;
                bOrderPhoneCol.innerHTML = listOrderObjects[bI].soDienThoai;
                bOrderStatusCol.innerHTML = listOrderObjects[bI].trangThai;
                //bOrderDetailCol.innerHTML = "<button data-id='" + listOrderObjects[bI].id + "' data-ordercode='" + listOrderObjects[bI].orderCode + "' class='btn btn-info' onclick='onBtnOrderDetailClick(this)' >Chi tiết</button>";

                var bButtonDetail = document.createElement("button");
                bButtonDetail.innerHTML = "Chi tiết";
                bButtonDetail.className = "btn btn-info";
                bButtonDetail.setAttribute("data-id", listOrderObjects[bI].id);
                bButtonDetail.setAttribute("ordercode", listOrderObjects[bI].orderCode);
                bButtonDetail.addEventListener("click", function () {
                    onBtnOrderDetailClick(this);
                });

                bOrderDetailCol.appendChild(bButtonDetail);
            }

        }

    </script>
</body>

</html>